SystemOrganization addCategory: #RSSNewsReader!

Object subclass: #RSSNewsReader
	instanceVariableNames: 'list index urlList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RSSNewsReader'!

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/21/2013 09:30'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self;
		label: 'News Reader';
		extent: 300@400;
		children: OrderedCollection new.
	listSpec := builder pluggableListSpec new.
	listSpec model: self;
		list: #list;
		getIndex: #getIndex;
		setIndex: #setIndex:;
		frame: (0@0 corner: 1@0.92).
	windowSpec children add: listSpec.
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.92 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec.! !

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/21/2013 08:05'!
getIndex
	^index! !

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/21/2013 08:17'!
initialize
	list := OrderedCollection new.
	urlList := OrderedCollection new.
	index := 0.! !

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/21/2013 08:03'!
list
	^list! !

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/25/2013 07:39'!
refresh
	| url stream xml |
	
	url := HttpUrl absoluteFromText: 'http://yle.fi/uutiset/rss/uutiset.rss'.
	"url := HttpUrl absoluteFromText: 'http://feeds.bbci.co.uk/news/rss.xml'."
	stream := url retrieveContents contentStream.
	xml := XMLDOMParser parseDocumentFrom: stream.
	index := 0.
	self changed: #getIndex.
	list removeAll.
	urlList removeAll.
	self changed: #list.
	xml tagsNamed: #item do: [ :element |
		element elementsDo: [ :element2 |
			element2 name = 'title' ifTrue: [
				list add: element2 contentString utf8ToSqueak.
			].
			element2 name = 'link' ifTrue: [
				urlList add: element2 contentString.
			].
		].
	].
	self changed: #list.! !

!RSSNewsReader methodsFor: 'as yet unclassified' stamp: 'MJK 3/21/2013 08:41'!
setIndex: anInteger
	index := anInteger.
	self changed: #getIndex.
	index = 0 ifFalse: [ Win32Shell new shellOpen: (urlList at: index) ].! !
